.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include test_uni.inc

.data
	lang_id   dd 9h                          ; language ID
	ini_file  db "langs.ini",0                 ; ini file
	ini_menu  db "S",0,"T",0,"R",0,0,0       ; [STR]
	ini_item0 db "O",0,"P",0,"e",0,"n",0,0,0 ; OPen=
	ini_item1 db "O",0,"P",0,"l",0,"t",0,0,0 ; OPlt=
	ini_item2 db "O",0,"P",0,"r",0,"u",0,0,0 ; OPru=
	ini_def   db "C",0,"h",0,"a",0,"n",0,"g",0,"e",0," ",0,"L",0,"a",0,"n",0,"g",0,"u",0,"a",0,"g",0,"e",0,0,0 ; default string
	path  db 256 dup (0)
	path2 db 512 dup (0)
.code

start:
	
	invoke GetModuleHandle,NULL
	mov	   hInstance, eax
    invoke InitCommonControls
	invoke DialogBoxParamW, hInstance, 1000, 0, ADDR DlgProc, 0
	invoke ExitProcess, 0

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL str_uni[512]:BYTE
	LOCAL lang_ptr:DWORD
	
	mov		eax, uMsg
	.if eax==WM_INITDIALOG
		invoke GetAppPath, ADDR path
		invoke szCatStr,   ADDR path, ADDR ini_file
		invoke MultiByteToWideChar, CP_ACP, MB_PRECOMPOSED, ADDR path, -1, ADDR path2, 512
		invoke GetPrivateProfileStringW, ADDR ini_menu, ADDR ini_item0, ADDR ini_def, ADDR str_uni, 512, ADDR path2
		invoke SetDlgItemTextW, hWin, 1001, ADDR str_uni 
	.elseif eax==WM_COMMAND
		mov    eax, wParam
		.if eax == 10006
			mov    eax, lang_id
			.if eax == 9h
				mov    eax, 27h
				mov    lang_ptr, OFFSET ini_item1
			.elseif eax == 27h
				mov    eax, 19h
				mov    lang_ptr, OFFSET ini_item2
			.elseif eax == 19h
				mov    eax, 9h
				mov    lang_ptr, OFFSET ini_item0
			.endif
			mov    lang_id, eax
			invoke FindResourceEx, 0, RT_MENU, 10000, eax
			invoke LoadResource, 0,  eax
			invoke LoadMenuIndirect, eax
			invoke SetMenu, hWin,    eax
			;---------------------------
			invoke GetPrivateProfileStringW, ADDR ini_menu, lang_ptr, ADDR ini_def, ADDR str_uni, 512, ADDR path2
			invoke SetDlgItemTextW, hWin, 1001, ADDR str_uni 
		.endif
	.elseif eax == WM_CLOSE
		invoke EndDialog,hWin,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

end start
